]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- subst %{_libdir} -- it's more common to use %{_libdir} than %{_prefix}/lib and...
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739
AM
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
11262d99 25v0.17 (C) 1999-2007 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739 41UPDATE=""
cd445739
AM
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
d1c5a9a7 64RPMBUILDOPTS=""
cd445739
AM
65BCOND=""
66GROUP_BCONDS="no"
947025e5 67CVSIGNORE_DF="no"
d287305c 68
69PATCHES=""
70SOURCES=""
cd445739 71ICONS=""
d287305c 72PACKAGE_RELEASE=""
73PACKAGE_VERSION=""
74PACKAGE_NAME=""
cd445739
AM
75PROTOCOL="ftp"
76WGET_RETRIES=${MAX_WGET_RETRIES:-0}
77CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
78
79CVSTAG=""
80RES_FILE=""
39dcc7de 81CVS_FORCE=""
cd445739
AM
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
975d7b23 95TRY_UPGRADE=""
257af81b
ER
96# should the specfile be restored if upgrade failed?
97REVERT_BROKEN_UPGRADE="yes"
98
ab4a2b6e 99if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 100 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 101else
ce40491a 102 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
103fi
104
cd445739
AM
105# Here we load saved user environment used to
106# predefine options set above, or passed to builder
107# in command line.
108# This one reads global system environment settings:
109if [ -f ~/etc/builderrc ]; then
110 . ~/etc/builderrc
111fi
112# And this one cascades settings using user personal
113# builder settings.
114# Example of ~/.builderrc:
115#
116#UPDATE_POLDEK_INDEXES="yes"
117#FETCH_BUILD_REQUIRES="yes"
118#REMOVE_BUILD_REQUIRES="force"
119#GROUP_BCONDS="yes"
120#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 121#TITLECHANGE=no
cd445739 122#
a83e5405 123SU_SUDO=""
cd445739
AM
124if [ -n "$HOME_ETC" ]; then
125 USER_CFG="$HOME_ETC/.builderrc"
126else
127 USER_CFG=~/.builderrc
128fi
129
130[ -f "$USER_CFG" ] && . "$USER_CFG"
131
86aafdbe
ER
132if [ "$SCHEDTOOL" = "auto" ]; then
133 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
134 SCHEDTOOL="schedtool -B -e"
135 else
136 SCHEDTOOL="no"
137 fi
138fi
139
ca2e6c31 140if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
141 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
142 GETURI2="$GETURI"
143 OUTFILEOPT="-O"
ca2e6c31 144elif [ -n "$USE_AXEL" ]; then
cede92b3 145 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
146 GETURI2="$GETURI"
147 OUTFILEOPT="-o"
ca2e6c31 148else
5700ee32
ER
149 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
150 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
151 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 152
7e365483
KK
153 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
154 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
155 OUTFILEOPT="-O"
2bc5451f 156fi
11468b23 157
11468b23
AM
158GETLOCAL="cp -a"
159
160if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
161 RPM="rpm"
162 RPMBUILD="rpm"
163else
164 RPM="rpm"
165 RPMBUILD="rpmbuild"
166fi
167
168POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 169POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 170
cd445739
AM
171run_poldek()
172{
173 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
174 if [ -n "$LOGFILE" ]; then
175 LOG=`eval echo $LOGFILE`
176 if [ -n "$LASTLOG_FILE" ]; then
177 echo "LASTLOG=$LOG" > $LASTLOG_FILE
178 fi
86aafdbe 179 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
180 return $exit_pldk
181 else
86aafdbe 182 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
183 return `cat ${RES_FILE}`
184 rm -rf ${RES_FILE}
185 fi
186}
187
cd445739
AM
188#---------------------------------------------
189# functions
da946cd6 190
5a491465 191usage()
192{
cd445739
AM
193 if [ -n "$DEBUG" ]; then set -xv; fi
194 echo "\
195Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
6594293d 196[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 197[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 198[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
199[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 200[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 201[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d
AG
202[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
203[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
204<package>[.spec][:cvstag]
2a5f078d 205
cd445739
AM
206-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
207-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
208-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
209-D, --debug - enable builder script debugging mode,
210-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
211-V, --version - output builder version
212-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
213-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
214 from <package>.spec,
215-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
216 only package from <package>.spec,
c56807e0 217-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
218-bc - execute the %build phase of <package>.spec,
219-bi - execute the %install phase of <package>.spec
220-bl - execute the %files phase of <package>.spec
cd445739
AM
221-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
222 them into src.rpm,
6594293d 223--short-circuit - short-circuit build
cd445739
AM
224-B, --branch - add branch
225-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
226 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 227-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 228-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
229 - setup \$CVSROOT,
230--define <macro> <value>
231 - define a macro <macro> with value <value>,
232--nodeps - rpm won't check any dependences
233-g, --get - get <package>.spec and all related files from CVS repo
234 or HTTP/FTP,
235-h, --help - this message,
236--http - use http instead of ftp,
237-l <logfile>, --logtofile <logfile>
238 - log all to file,
239-m, --mr-proper - only remove all files related to spec file and all work
240 resources,
241-nc, --no-cvs - don't download sources from CVS, if source URL is given,
242-ncs, --no-cvs-specs
243 - don't check specs in CVS
244-nd, --no-distfiles - don't download from distfiles
245-nm, --no-mirrors - don't download from mirror, if source URL is given,
246-nu, --no-urls - don't try to download from FTP/HTTP location,
247-ns, --no-srcs - don't download Sources
248-ns0, --no-source0 - don't download Source0
249-nn, --no-net - don't download anything from the net
b572253e 250--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
251-ske,
252--skip-existing-files - skip existing files in get_files
cd445739
AM
253--opts <rpm opts> - additional options for rpm
254-q, --quiet - be quiet,
255--date yyyy-mm-dd - build package using resources from specified CVS date,
256-r <cvstag>, --cvstag <cvstag>
257 - build package using resources from specified CVS tag,
5323fffd 258-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
259-R, --fetch-build-requires
260 - fetch what is BuildRequired,
261-RB, --remove-build-requires
262 - remove all you fetched with -R or --fetch-build-requires
263 remember, this option requires confirmation,
264-FRB, --force-remove-build-requires
265 - remove all you fetched with -R or --fetch-build-requires
266 remember, this option works without confirmation,
06541433
JR
267-sd, --source-distfiles - list sources available from distfiles (intended for offline
268 operations; does not work when Icon field is present
269 but icon file is absent),
270-sdp, --source-distfiles-paths - list sources available from distfiles -
271 paths relative to distfiles directory (intended for offline
272 operations; does not work when Icon field is present
273 but icon file is absent),
a7eefc54 274-sf, --source-files - list sources - bare filenames (intended for offline
275 operations; does not work when Icon field is present
3621e588 276 but icon file is absent),
a7eefc54 277-sp, --source-paths - list sources - filenames with full local paths (intended for
278 offline operations; does not work when Icon field is present
3621e588 279 but icon file is absent),
2dddf439
ER
280-su, --source-urls - list urls - urls to sources and patches
281 intended for copying urls with spec with lots of macros in urls
cd445739
AM
282-T <cvstag> , --tag <cvstag>
283 - add cvs tag <cvstag> for files,
284-Tvs, --tag-version-stable
094bd95b 285 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
286-Ts, --tag-stable
287 - add cvs tag STABLE for files,
cd445739 288-Tv, --tag-version
1691a37b 289 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
290-Tp, --tag-prefix <prefix>
291 - add <prefix> to NAME-VERSION-RELEASE tags,
292-tt, --test-tag <prefix>
293 - fail if tag is already present,
50321881
JK
294-ir, --integer-release-only
295 - allow only integer and snapshot releases
cd445739
AM
296-v, --verbose - be verbose,
297-u, --try-upgrade - check version, and try to upgrade package
298-un, --try-upgrade-with-float-version
299 - as above, but allow float version
deccc50e 300-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
301-Upi, --update-poldek-indexes
302 - refresh or make poldek package index files.
c890b916 303-np, --nopatch <patchnumber>
bed98670 304 - don't apply <patchnumber>
dfe2cb9a
MK
305--show-bconds - show available conditional builds, which can be used
306 - with --with and/or --without switches.
9b78be50
ER
307--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
308 ./repackage.sh script. in other words, the output is
309 parseable by scripts.
cd445739
AM
310--with/--without <feature>
311 - conditional build package depending on %_with_<feature>/
312 %_without_<feature> macro switch. You may now use
313 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
314 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 315--target <platform>, --target=<platform>
3621e588
ER
316 - build for platform <platform>.
317--init-rpm-dir - initialize ~/rpm directory structure
5a491465 318"
319}
320
c890b916 321update_shell_title() {
a0d6396b 322 [ -t 1 ] || return
0b65d15e
ER
323 local len=${COLUMNS:-80}
324 local msg=$(echo "$*" | cut -c-$len)
325
e225de91
ER
326 if [ -n "$BE_VERBOSE" ]; then
327 echo >&2 "$(date +%s.%N) $*"
328 fi
329
982e358c 330 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
331 local pkg
332 if [ -n "$PACKAGE_NAME" ]; then
333 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
334 else
335 pkg=${SPECFILE}
336 fi
337
338 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 339 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
340 case "$TERM" in
341 cygwin|xterm*)
342 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
343 ;;
344 screen*)
345 echo >&2 -ne "\033]0;$msg\007"
346 ;;
347 esac
348 fi
c890b916
ER
349}
350
7e40520f
ER
351# set TARGET from BuildArch: from SPECFILE
352set_spec_target() {
ce40491a
ER
353 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
354 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
355 if [ "$tmp" ]; then
f9109a96 356 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
357 TARGET="$tmp"
358 case "$RPMBUILD" in
359 "rpmbuild")
f9109a96 360 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 361 "rpm")
ce40491a 362 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 363 esac
ce40491a
ER
364 fi
365 fi
7e40520f
ER
366}
367
cd445739 368cache_rpm_dump () {
d22150da 369 if [ -n "$DEBUG" ]; then
518ff1fb
ER
370 set -x
371 set -v
d22150da 372 fi
7e40520f 373
13974367 374 update_shell_title "cache_rpm_dump"
237bd3f1
ER
375 local rpm_dump
376 rpm_dump=`
d05e8080 377
fa4bf1df 378 # we reset macros not to contain macros.build as all the %() macros are
559d511f 379 # executed here, while none of them are actually needed.
fa4bf1df 380 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 381 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 382 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 383 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
8ebeba63
AM
384 if [ -f /usr/lib/rpm/rpmrc ]; then
385 # FIXME: better ideas than .rpmrc?
386 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
387 else
388 printf 'macrofiles:%s\n' $macrofiles > .builder-rpmrc
389 fi
fb198857 390# TODO: move these to /usr/lib/rpm/macros
36433112 391 cat > .builder-rpmmacros <<'EOF'
f78a0bb7 392%alt_kernel %{nil}
393%_alt_kernel %{nil}
fb198857
ER
394%requires_releq_kernel_up %{nil}
395%requires_releq_kernel_smp %{nil}
6b8134e3 396%requires_releq() %{nil}
bb01dee9 397%pyrequires_eq() %{nil}
559d511f 398%requires_eq() %{nil}
c13be3d1 399%requires_eq_to() %{nil}
fb198857
ER
400%releq_kernel_up ERROR
401%releq_kernel_smp ERROR
74d9fd14 402%kgcc_package ERROR
237bd3f1 403%_fontsdir ERROR
7141278d 404%ruby_version ERROR
405%ruby_ver_requires_eq() %{nil}
406%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 407%__php_api_requires() %{nil}
7141278d 408%php_major_version ERROR
409%php_api_version ERROR
410%py_ver ERROR
41035426
ER
411%perl_vendorarch ERROR
412%perl_vendorlib ERROR
703ae20b
ER
413# damn. need it here! - copied from /usr/lib/rpm/macros.build
414%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
415%patchset_source(f:b:) %(
416 base=%{-b*}%{!-b*:10000};
417 start=$(expr $base + %1);
418 end=$(expr $base + %{?2}%{!?2:%{1}});
419 # we need to call seq twice as it doesn't allow two formats
420 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
421 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
422 paste %{tmpdir}/__ps{1,2};
423 rm -f %{tmpdir}/__ps{1,2};
424) \
425%{nil}
fb198857 426EOF
cd445739 427 case "$RPMBUILD" in
237bd3f1
ER
428 rpm)
429 ARGS='-bp'
430 ;;
431 rpmbuild)
432 ARGS='--nodigest --nosignature --nobuild'
433 ;;
434 esac
3d12d055
JR
435 if [ "$NOINIT" = "yes" ] ; then
436 cat >> .builder-rpmmacros <<'EOF'
437%_specdir ./
438%_sourcedir ./
439EOF
c039643c
JR
440 fi
441 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 442 `
fb198857 443 if [ $? -gt 0 ]; then
237bd3f1
ER
444 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
445 echo "$error" >&2
518ff1fb 446 Exit_error err_build_fail
fb198857 447 fi
d05e8080
ER
448
449 # make small dump cache
450 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
451 $2 ~ /^SOURCEURL/ {print}
452 $2 ~ /^PATCHURL/ {print}
453 $2 ~ /^nosource/ {print}
454 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
455 '`
456
13974367 457 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
458}
459
460rpm_dump () {
461 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 462 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
463 fi
464 echo "$rpm_dump_cache"
465}
466
d05e8080
ER
467get_icons()
468{
469 update_shell_title "get icons"
470 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
471 if [ -z "$ICONS" ]; then
472 return
473 fi
474
975d7b23 475 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
476}
477
59398507 478parse_spec()
479{
af4d5315 480 update_shell_title "parsing specfile"
cd445739 481 if [ -n "$DEBUG" ]; then
518ff1fb
ER
482 set -x
483 set -v
cd445739 484 fi
b2975fc3 485
d05e8080 486 # icons are needed for successful spec parse
518ff1fb 487 get_icons
d05e8080 488
cd445739 489 cd $SPECS_DIR
cd445739 490 cache_rpm_dump
00fcec7e 491
cd445739
AM
492 if [ "$NOSRCS" != "yes" ]; then
493 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
494 fi
7cb24972 495
cd445739
AM
496 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
497 FAIL_IF_NO_SOURCES="no"
498 fi
499
500 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
501 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
502 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
503 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
504 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 505
cd445739
AM
506 if [ -n "$BE_VERBOSE" ]; then
507 echo "- Sources : `nourl $SOURCES`"
508 if [ -n "$PATCHES" ]; then
509 echo "- Patches : `nourl $PATCHES`"
510 else
511 echo "- Patches : *no patches needed*"
512 fi
513 if [ -n "$ICONS" ]; then
514 echo "- Icon : `nourl $ICONS`"
515 else
516 echo "- Icon : *no package icon*"
517 fi
518 echo "- Name : $PACKAGE_NAME"
519 echo "- Version : $PACKAGE_VERSION"
520 echo "- Release : $PACKAGE_RELEASE"
521 fi
13974367
ER
522
523 update_shell_title "parse_spec: OK!"
cd445739
AM
524}
525
526Exit_error()
527{
528 if [ -n "$DEBUG" ]; then
518ff1fb
ER
529 set -x
530 set -v
cd445739
AM
531 fi
532
533 cd "$__PWD"
534
535 case "$1" in
536 "err_no_spec_in_cmdl" )
537 remove_build_requires
518ff1fb 538 echo "ERROR: spec file name not specified."
cd445739
AM
539 exit 2 ;;
540 "err_no_spec_in_repo" )
541 remove_build_requires
518ff1fb 542 echo "Error: spec file not stored in CVS repo."
cd445739
AM
543 exit 3 ;;
544 "err_no_source_in_repo" )
545 remove_build_requires
518ff1fb 546 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
547 exit 4 ;;
548 "err_build_fail" )
549 remove_build_requires
518ff1fb 550 echo "Error: package build failed. (${2:-no more info})"
cd445739 551 exit 5 ;;
78eab2a1
AM
552 "err_no_package_data" )
553 remove_build_requires
554 echo "Error: couldn't get out package name/version/release from spec file."
555 exit 6 ;;
ce40491a 556 "err_tag_exists" )
50321881 557 remove_build_requires
518ff1fb 558 echo "Tag ${2} already exists (spec release: ${3})."
50321881 559 exit 9 ;;
ce40491a 560 "err_fract_rel" )
50321881 561 remove_build_requires
518ff1fb 562 echo "Release ${2} not integer and not a snapshot."
50321881 563 exit 10 ;;
fb96e0b5
AM
564 "err_branch_exists" )
565 remove_build_requires
518ff1fb 566 echo "Tree branch already exists (${2})."
fb96e0b5 567 exit 11 ;;
cfc497c0
ER
568 "err_acl_deny" )
569 remove_build_requires
570 echo "Error: conditions reject building this spec (${2})."
571 exit 12 ;;
50321881 572
cd445739 573 esac
73848362
ER
574 echo "Unknown error."
575 exit 100
cd445739
AM
576}
577
578init_builder()
579{
580 if [ -n "$DEBUG" ]; then
518ff1fb
ER
581 set -x
582 set -v
0dd6320d 583 fi
cd445739 584
4aeb9973 585 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
586 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
587 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
588 else
589 SOURCE_DIR="."
590 SPECS_DIR="."
591 fi
cd445739
AM
592
593 __PWD="`pwd`"
00fcec7e 594}
595
d6a77ddb 596get_spec()
1471f6d6 597{
c890b916 598
2e5be021 599 update_shell_title "get_spec"
c890b916 600
cd445739 601 if [ -n "$DEBUG" ]; then
518ff1fb
ER
602 set -x
603 set -v
cd445739
AM
604 fi
605
606 cd "$SPECS_DIR"
049ab214 607 if [ ! -f "$SPECFILE" ]; then
518ff1fb 608 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
609 fi
610 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 611
049ab214
ER
612 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
613 echo "Warning: No CVS access defined - using local .spec file"
614 NOCVSSPEC="yes"
cd445739
AM
615 fi
616
049ab214 617 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 618 fi
049ab214 619
cd445739 620 if [ ! -f "$SPECFILE" ]; then
518ff1fb 621 Exit_error err_no_spec_in_repo
cd445739
AM
622 fi
623
624 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
625 chmod $CHMOD_MODE $SPECFILE
626 fi
627 unset OPTIONS
a7eefc54 628 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 629
ce40491a 630 set_spec_target
cd445739
AM
631}
632
633find_mirror()
634{
635 cd "$SPECS_DIR"
782518da 636 local url="$1"
cd445739
AM
637 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
638 cvs update mirrors >&2
639 fi
640
641 IFS="|"
782518da
ER
642 local origin mirror name rest ol prefix
643 while read origin mirror name rest; do
644 # skip comments and empty lines
645 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
646 continue
647 fi
cd445739
AM
648 ol=`echo -n "$origin"|wc -c`
649 prefix="`echo -n "$url" | head -c $ol`"
650 if [ "$prefix" = "$origin" ] ; then
782518da 651 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
652 echo -n "$mirror$suffix"
653 return 0
654 fi
655 done < mirrors
656 echo "$url"
657}
658
e7e0d4ec 659# Warning: unpredictable results if same URL used twice
cd445739
AM
660src_no ()
661{
662 cd $SPECS_DIR
663 rpm_dump | \
664 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
665 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
666 head -n 1 | xargs
1471f6d6 667}
668
e7e0d4ec 669src_md5()
8ba5cdda 670{
e7e0d4ec 671 [ "$NO5" = "yes" ] && return
cd445739
AM
672 no=$(src_no "$1")
673 [ -z "$no" ] && return
674 cd $SPECS_DIR
e7e0d4ec
ER
675 local md5
676
677 if [ -f additional-md5sums ]; then
678 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
679 if [ -z "$spec_rev" ]; then
680 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
681 fi
682 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
683 md5=$(grep -s -v '^#' additional-md5sums | \
684 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
685 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
686 grep -E '^[0-9a-f]{32}$')
687
688 if [ "$md5" ]; then
689 if [ $(echo "$md5" | wc -l) != 1 ] ; then
690 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
691 fi
692 echo "$md5" | tail -n 1
693 return
694 fi
cd445739 695 fi
e7e0d4ec
ER
696
697 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
698 if [ -n "$source_md5" ]; then
699 echo $source_md5
cd445739 700 else
e7e0d4ec
ER
701 # we have empty SourceX-md5, but it is still possible
702 # that we have NoSourceX-md5 AND NoSource: X
703 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 704 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 705 echo $nosource_md5
cd445739 706 fi
cd445739
AM
707 fi
708}
709
06541433
JR
710distfiles_path ()
711{
712 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
713}
714
cd445739
AM
715distfiles_url ()
716{
06541433 717 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
718}
719
720distfiles_attic_url ()
721{
06541433 722 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
723}
724
725good_md5 ()
726{
727 md5=$(src_md5 "$1")
728 [ "$md5" = "" ] || \
729 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
730}
731
a4b50627
AF
732good_size ()
733{
ce40491a
ER
734 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
735 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
736}
737
947025e5 738cvsignore_df ()
739{
740 if [ "$CVSIGNORE_DF" != "yes" ]; then
741 return
742 fi
743 cvsignore=${SOURCE_DIR}/.cvsignore
744 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
745 echo "$1" >> $cvsignore
746 fi
747}
748
e7fa3b9f
ER
749cvsup()
750{
ce40491a
ER
751 update_shell_title "cvsup"
752 local OPTIONS="up "
753 if [ -n "$CVSROOT" ]; then
754 OPTIONS="-d $CVSROOT $OPTIONS"
755 fi
b1c6aace 756
ce40491a
ER
757 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
758 OPTIONS="$OPTIONS -A"
759 else
760 if [ -n "$CVSDATE" ]; then
761 OPTIONS="$OPTIONS -D $CVSDATE"
762 fi
763 if [ -n "$CVSTAG" ]; then
764 OPTIONS="$OPTIONS -r $CVSTAG"
765 fi
766 fi
e7fa3b9f 767
ce40491a
ER
768 local result=1
769 local retries_counter=0
770 if [ $# = 1 ]; then
771 update_shell_title "cvsup: $*"
772 else
773 update_shell_title "cvsup: $# files"
774 fi
775 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
776 retries_counter=$(( $retries_counter + 1 ))
777 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
778 result=$?
779 [ -n "$output" ] && echo "$output"
780 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
781 echo "Trying again [$*]... ($retries_counter)"
782 update_shell_title "cvsup: retry #$retries_counter"
783 sleep 2
784 continue
785 else
786 break
787 fi
788 done
789 update_shell_title "cvsup: done!"
790 return $result
e7fa3b9f
ER
791}
792
71f8e908
ER
793# returns true if "$1" is ftp, http or https protocol url
794is_url()
795{
796 case "$1" in
797 ftp://*|http://*|https://*)
798 return 0
799 ;;
800 esac
801 return 1
802}
803
ecba6ad5
ER
804update_md5()
805{
806 if [ $# -eq 0 ]; then
807 return
808 fi
809
810 update_shell_title "update md5"
811 if [ -n "$DEBUG" ]; then
518ff1fb
ER
812 set -x
813 set -v
ecba6ad5
ER
814 fi
815
816 cd "$SOURCE_DIR"
817
818 # pass 1: check files to be fetched
819 local todo
820 local need_files
821 for i in "$@"; do
822 local fp=$(nourl "$i")
823 local srcno=$(src_no "$i")
6392b5fd
ER
824 if [ -n "$ADD5" ]; then
825 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
826 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
827 else
828 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
829 fi
830 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
831 need_files="$need_files $i"
832 fi
833 done
834
835 # pass 1a: get needed files
836 if [ "$need_files" ]; then
837 get_files $need_files
838 fi
839
840 # pass 2: proceed with md5 adding or updating
841 for i in "$@"; do
842 local fp=$(nourl "$i")
843 local srcno=$(src_no "$i")
71f8e908
ER
844 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
845 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
846 local tag="Source$srcno-md5"
847 if [[ "$md5" == *NoSource* ]]; then
848 tag="NoSource$srcno-md5"
849 fi
ecba6ad5 850 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 851 echo "Updating $tag ($md5: $fp)."
ecba6ad5 852 perl -i -ne '
71f8e908
ER
853 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
854 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
855 ' \
856 $SPECS_DIR/$SPECFILE
857 fi
858 done
859}
860
861check_md5()
862{
863 update_shell_title "check md5"
864
865 for i in "$@"; do
866 if good_md5 "$i" && good_size "$i"; then
867 continue
868 fi
869
870 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
871 echo "or -5 to update md5 sums, if you're sure files are correct."
872 Exit_error err_no_source_in_repo $i
873 done
874}
875
cd445739
AM
876get_files()
877{
7cb24972 878 update_shell_title "get_files"
cd445739
AM
879
880 if [ -n "$DEBUG" ]; then
518ff1fb
ER
881 set -x
882 set -v
cd445739
AM
883 fi
884
f09c0772 885 if [ $# -gt 0 ]; then
cd445739
AM
886 cd "$SOURCE_DIR"
887
b1c6aace 888 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 889 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
890 NOCVS="yes"
891 fi
892
f2e42a41 893 local nc=0
e7fa3b9f 894 local get_files_cvs=""
3815b69a 895 for i in "$@"; do
f2e42a41 896 nc=$((nc + 1))
dcebdffb 897 local cvsup=0
3815b69a 898 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 899 update_shell_title "$i"
f09c0772 900 local fp=`nourl "$i"`
ecba6ad5 901 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 902 continue
18e5347d 903 fi
ecba6ad5 904
cd445739 905 FROM_DISTFILES=0
e7e0d4ec 906 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
907
908 # we know if source/patch is present in cvs/distfiles
909 # - has md5 (in distfiles)
910 # - in cvs... ideas?
911
912 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 913 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
914 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
915 echo "Warning: no URL given for $i"
916 fi
917
e7e0d4ec 918 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 919 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 920 echo "$fp having proper md5sum already exists"
cd445739
AM
921 continue
922 fi
4ea1c265 923 target="$fp"
28b34560
ER
924
925 # prefer mirror over distfiles if there's mirror
926 # TODO: build url list and then try each url from the list
927 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
928 url="$im"
929 else
930 url=$(distfiles_url "$i")
931 fi
932
cd445739
AM
933 url_attic=$(distfiles_attic_url "$i")
934 FROM_DISTFILES=1
ecba6ad5
ER
935 # is $url local file?
936 if [[ "$url" = [./]* ]]; then
18a52930 937 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
938 ${GETLOCAL} $url $target
939 else
940 if [ -z "$NOMIRRORS" ]; then
9e9f8920 941 url=$(find_mirror "$url")
cd445739 942 fi
9e9f8920
ER
943
944 local uri=${url}
945 # make shorter message for distfiles urls
946 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
947 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
948 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
949 uri="df: $uri"
950 fi
951 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 952 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 953 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 954 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 955 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
956 fi
957 fi
ecba6ad5
ER
958
959 # is it empty file?
960 if [ ! -s "$target" ]; then
cd445739
AM
961 rm -f "$target"
962 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 963 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
964 ${GETLOCAL} $url_attic $target
965 else
966 if [ -z "$NOMIRRORS" ]; then
967 url_attic="`find_mirror "$url_attic"`"
968 fi
18a52930 969 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 970 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 971 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 972 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 973 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
974 fi
975 fi
976 fi
ecba6ad5
ER
977
978 if [ -s "$target" ]; then
947025e5 979 cvsignore_df $target
980 else
cd445739
AM
981 rm -f "$target"
982 FROM_DISTFILES=0
983 fi
e7e0d4ec 984 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
985 if [ $# -gt 1 ]; then
986 get_files_cvs="$get_files_cvs $fp"
987 update_shell_title "$fp (will cvs up later)"
988 cvsup=1
989 else
990 cvsup $fp
991 fi
cd445739
AM
992 fi
993
f09c0772 994 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
995 if [ -z "$NOMIRRORS" ]; then
996 im="`find_mirror "$i"`"
997 else
998 im="$i"
999 fi
ce40491a 1000 update_shell_title "${GETURI%% *}: $im"
cd445739 1001 ${GETURI} "$im" || \
33da77c4 1002 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1003 update_shell_title "${GETURI2%% *}: $im"
cd445739 1004 ${GETURI2} "$im"
7e365483 1005 fi
cd445739
AM
1006 fi
1007
dcebdffb
ER
1008 if [ "$cvsup" = 1 ]; then
1009 continue
1010 fi
1011
cd445739 1012 fi
ecba6ad5
ER
1013
1014 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1015 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 1016 Exit_error err_no_source_in_repo $i
cd445739 1017 fi
2a5f078d 1018
ecba6ad5 1019 # we check md5 here just only to refetch immediately
a4b50627 1020 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1021 :
1022 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1023 # wrong md5 from distfiles: remove the file and try again
cd445739 1024 # but only once ...
deccc50e 1025 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1026 FROM_DISTFILES=2
1027 rm -f $target
18a52930 1028 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1029 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1030 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1031 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1032 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1033 fi
ecba6ad5 1034 if [ ! -s "$target" ]; then
cd445739 1035 rm -f "$target"
18a52930 1036 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1037 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1038 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1039 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1040 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1041 fi
1042 fi
1043 test -s "$target" || rm -f "$target"
1044 fi
cd445739 1045 done
e7fa3b9f
ER
1046 SHELL_TITLE_PREFIX=""
1047
1048 if [ "$get_files_cvs" ]; then
ce40491a 1049 cvsup $get_files_cvs
e7fa3b9f 1050 fi
cd445739
AM
1051
1052 if [ "$CHMOD" = "yes" ]; then
3815b69a 1053 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1054 if [ -n "$CHMOD_FILES" ]; then
1055 chmod $CHMOD_MODE $CHMOD_FILES
1056 fi
1057 fi
cd445739
AM
1058 fi
1059}
1060
1061make_tagver() {
ce40491a 1062 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1063 set -x
1064 set -v
ce40491a 1065 fi
78eab2a1 1066
ce40491a
ER
1067 # Check whether first character of PACKAGE_NAME is legal for tag name
1068 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1069 TAG_PREFIX=tag_
1070 fi
1071 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
1072 # Remove #kernel.version_release from TAGVER because tagging sources
1073 # could occur with different kernel-headers than kernel-headers used at build time.
1074 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
1075 echo -n "$TAGVER"
cd445739
AM
1076}
1077
1078tag_files()
1079{
1080 TAG_FILES="$@"
1081
1082 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1083 set -x
1084 set -v
cd445739
AM
1085 fi
1086
73ef63d8
ER
1087 echo "Version: $PACKAGE_VERSION"
1088 echo "Release: $PACKAGE_RELEASE"
cd445739 1089
73ef63d8 1090 TAGVER=`make_tagver`
cd445739 1091
73ef63d8
ER
1092 if [ "$TAG_VERSION" = "yes" ]; then
1093 echo "CVS tag: $TAGVER"
1094 fi
1095 if [ -n "$TAG" ]; then
1096 echo "CVS tag: $TAG"
1097 fi
cd445739 1098
39dcc7de 1099 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1100 if [ -n "$CVSROOT" ]; then
1101 OPTIONS="-d $CVSROOT $OPTIONS"
1102 fi
cd445739 1103
73ef63d8
ER
1104 cd "$SOURCE_DIR"
1105 local tag_files
1106 for i in $TAG_FILES; do
1107 # don't tag files stored on distfiles
1108 [ -n "`src_md5 $i`" ] && continue
1109 local fp=`nourl "$i"`
1110 if [ -f "$fp" ]; then
1111 tag_files="$tag_files $fp"
1112 else
1113 Exit_error err_no_source_in_repo $i
03db3356 1114 fi
73ef63d8 1115 done
03db3356 1116
73ef63d8 1117 if [ "$tag_files" ]; then
cd445739 1118 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8
ER
1119 update_shell_title "tag sources: $TAGVER"
1120 cvs $OPTIONS $TAGVER $tag_files
cd445739
AM
1121 fi
1122 if [ -n "$TAG" ]; then
73ef63d8
ER
1123 update_shell_title "tag sources: $TAG"
1124 cvs $OPTIONS $TAG $tag_files
cd445739 1125 fi
73ef63d8
ER
1126 fi
1127
1128 cd "$SPECS_DIR"
1129 if [ "$TAG_VERSION" = "yes" ]; then
1130 update_shell_title "tag spec: $TAGVER"
1131 cvs $OPTIONS $TAGVER $SPECFILE
1132 fi
1133 if [ -n "$TAG" ]; then
1134 update_shell_title "tag spec: $TAG"
1135 cvs $OPTIONS $TAG $SPECFILE
1136 fi
cd445739
AM
1137}
1138
1139branch_files()
1140{
1141 TAG=$1
1142 echo "CVS branch tag: $TAG"
518ff1fb 1143 shift
cd445739
AM
1144
1145 TAG_FILES="$@"
1146
1147 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1148 set -x
1149 set -v
cd445739
AM
1150 fi
1151
78a5a506
ER
1152 local OPTIONS="tag $CVS_FORCE -b"
1153 if [ -n "$CVSROOT" ]; then
1154 OPTIONS="-d $CVSROOT $OPTIONS"
1155 fi
1156 cd "$SOURCE_DIR"
1157 local tag_files
1158 for i in $TAG_FILES; do
1159 local fp=`nourl "$i"`
1160 if [ -f "$fp" ]; then
1161 tag_files="$tag_files $fp"
1162 else
1163 Exit_error err_no_source_in_repo $i
c10fa4fa 1164 fi
78a5a506
ER
1165 done
1166 if [ "$tag_files" ]; then
1167 cvs $OPTIONS $TAG $tag_files
1168 fi
c10fa4fa 1169
78a5a506
ER
1170 cd "$SPECS_DIR"
1171 cvs $OPTIONS $TAG $SPECFILE
cd445739
AM
1172}
1173
1174
1175
59398507 1176build_package()
1177{
2e5be021 1178 update_shell_title "build_package"
cd445739 1179 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1180 set -x
1181 set -v
cd445739 1182 fi
5a491465 1183
cd445739
AM
1184 cd "$SPECS_DIR"
1185
1186 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1187 update_shell_title "build_package: try_upgrade"
cd445739 1188 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1189 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1190 else
cc538c24 1191 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1192 fi
1193
1194 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1195
1196 if [ -n "$TNEWVER" ]; then
1197 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1198 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1199 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1200 cp -f $SPECFILE $SPECFILE.bak
1201 fi
cd445739
AM
1202 chmod +w $SPECFILE
1203 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1204 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1205 parse_spec
1206 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1207 update_md5 $SOURCES
975d7b23 1208
cd445739
AM
1209 unset TOLDVER TNEWVER TNOTIFY
1210 fi
1211 fi
1212 cd "$SPECS_DIR"
2a5f078d 1213
cd445739
AM
1214 case "$COMMAND" in
1215 build )
1216 BUILD_SWITCH="-ba" ;;
1217 build-binary )
1218 BUILD_SWITCH="-bb" ;;
1219 build-source )
1220 BUILD_SWITCH="-bs --nodeps" ;;
1221 build-prep )
1222 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1223 build-build )
1224 BUILD_SWITCH="-bc" ;;
1225 build-install )
1226 BUILD_SWITCH="-bi" ;;
1227 build-list )
1228 BUILD_SWITCH="-bl" ;;
1229
cd445739 1230 esac
c890b916 1231
2e5be021 1232 update_shell_title "build_package: $COMMAND"
cd445739
AM
1233 if [ -n "$LOGFILE" ]; then
1234 LOG=`eval echo $LOGFILE`
1235 if [ -d "$LOG" ]; then
1236 echo "Log file $LOG is a directory."
1237 echo "Parse error in the spec?"
518ff1fb 1238 Exit_error err_build_fail
cd445739
AM
1239 fi
1240 if [ -n "$LASTLOG_FILE" ]; then
1241 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1242 fi
1243 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1244 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1245 RETVAL=`cat $RES_FILE`
1246 rm $RES_FILE
1247 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1248 if [ "$RETVAL" -eq "0" ]; then
1249 mv $LOG $LOGDIROK
1250 else
1251 mv $LOG $LOGDIRFAIL
1252 fi
1253 fi
8ba5cdda 1254 else
86aafdbe 1255 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1256 RETVAL=$?
8ba5cdda 1257 fi
cd445739
AM
1258 if [ "$RETVAL" -ne "0" ]; then
1259 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1260 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1261 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1262 mv -f $SPECFILE.bak $SPECFILE
1263 fi
cd445739 1264 fi
518ff1fb 1265 Exit_error err_build_fail
cd445739
AM
1266 fi
1267 unset BUILD_SWITCH
1268}
1269
1270nourl()
1271{
1272 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1273}
1274
cd445739
AM
1275install_required_packages()
1276{
1277 run_poldek -vi $1
1278 return $?
1279}
1280
fa4bf1df
ER
1281find_spec_bcond() {
1282 # taken from find-spec-bcond, but with just getting the list
1283 local SPEC="$1"
1284 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1285 awk -F"\n" '
1286 /^%changelog/ { exit }
1287 /_with(out)?_[_a-zA-Z0-9]+/{
1288 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1289 print substr($0, RSTART, RLENGTH);
1290 }
1291 /^%bcond_with/{
1292 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1293 bcond = substr($0, RSTART +5 , RLENGTH -5);
1294 gsub(/[ \t]+/,"_",bcond);
1295 print bcond
1296 }' $SPEC | LC_ALL=C sort -u
1297}
1298
117d9861 1299process_bcondrc() {
301cbfd4
ER
1300 # expand bconds from ~/.bcondrc
1301 # The file structure is like gentoo's package.use:
1302 # ---
1303 # * -selinux
1304 # samba -mysql -pgsql
47a8df12 1305 # w32codec-installer license_agreement
301cbfd4
ER
1306 # php +mysqli
1307 # ---
fa4bf1df 1308 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1309 :
1310 else
1311 return
1312 fi
301cbfd4 1313
117d9861 1314 SN=${SPECFILE%%\.spec}
c8a3e2ac 1315
117d9861
ER
1316 local bcondrc=$HOME/.bcondrc
1317 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1318
117d9861 1319 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1320
117d9861
ER
1321 while read pkg flags; do
1322 # ignore comments
1323 [[ "$pkg" == \#* ]] && continue
1324
1325 # any package or current package?
1326 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1327 for flag in $flags; do
1328 local opt=${flag#[+-]}
1329
1330 # use only flags which are in this package.
1331 if [[ $bcond_avail = *${opt}* ]]; then
1332 if [[ $flag = -* ]]; then
1333 if [[ $BCOND != *--with?${opt}* ]]; then
1334 BCOND="$BCOND --without $opt"
1335 fi
1336 else
1337 if [[ $BCOND != *--without?${opt}* ]]; then
1338 BCOND="$BCOND --with $opt"
301cbfd4
ER
1339 fi
1340 fi
117d9861
ER
1341 fi
1342 done
1343 fi
1344 done < $bcondrc
1345 update_shell_title "parse ~/.bcondrc: DONE!"
1346}
1347
1348set_bconds_values()
1349{
1350 update_shell_title "set bcond values"
1351
1352 AVAIL_BCONDS_WITHOUT=""
1353 AVAIL_BCONDS_WITH=""
1354 if `grep -q ^%bcond ${SPECFILE}`; then
1355 BCOND_VERSION="NEW"
1356 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1357 BCOND_VERSION="OLD"
1358 else
1359 return
301cbfd4
ER
1360 fi
1361
117d9861
ER
1362 local bcond_avail=$(find_spec_bcond $SPECFILE)
1363 process_bcondrc "$SPECFILE"
1364
fa4bf1df 1365 update_shell_title "parse bconds"
cd445739 1366 case "${BCOND_VERSION}" in
fa4bf1df 1367 NONE)
7e365483 1368 :
cd445739 1369 ;;
7e365483 1370 OLD)
cd445739 1371 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1372 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1373 do
fa4bf1df
ER
1374 AVAIL_BCOND_WITHOUT=${opt#_without_}
1375 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1376 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1377 else
1378 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1379 fi
1380 done
2a5f078d 1381
fa4bf1df 1382 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1383 do
fa4bf1df
ER
1384 AVAIL_BCOND_WITH=${opt#_with_}
1385 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1386 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1387 else
1388 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1389 fi
1390 done
1391 ;;
1392 NEW)
fa4bf1df
ER
1393 local cond_type="" # with || without
1394 for opt in $bcond_avail; do
cd445739
AM
1395 case "$opt" in
1396 _without)
1397 cond_type="without"
1398 ;;
1399 _with)
1400 cond_type="with"
1401 ;;
f8d24cee 1402 _without_*)
fa4bf1df
ER
1403 AVAIL_BCOND_WITHOUT=${opt#_without_}
1404 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1405 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1406 else
1407 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1408 fi
1409 ;;
1410 _with_*)
fa4bf1df
ER
1411 AVAIL_BCOND_WITH=${opt#_with_}
1412 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1413 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1414 else
1415 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1416 fi
1417 ;;
cd445739
AM
1418 *)
1419 case "$cond_type" in
1420 with)
1421 cond_type=''
1422 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1423 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1424 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1425 else
1426 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1427 fi
7e365483 1428 ;;
cd445739
AM
1429 without)
1430 cond_type=''
1431 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1432 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1433 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1434 else
1435 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1436 fi
1437 ;;
1438 esac
1439 ;;
1440 esac
1441 done
1442 ;;
1443 esac
1444}
1445
1446run_sub_builder()
1447{
1448 package_name="${1}"
af6b168f 1449 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1450 #
1451